config/routes.rb
Rails.application.routes.draw do
  resources :articles
  resources :mailing_groups
  resources :other_groups
  resources :level_groups
  resources :subject_groups
  resources :mailing_statuses
  resources :user_groups
  resources :users
  root 'welcome#index'

resources :mailings do
    member do
      get :edit_comment
      patch :save_comment
      get :copy
    end

    resources :group_files
    resources :mailing_files
  end

  resources :sessions, only: [:new, :create, :destroy]

  match "/register", to: "users#new", via: "get"
  match '/signin',  to: 'sessions#new',         via: 'get'
  match '/signout', to: 'sessions#destroy',     via: 'delete'

  match "/calendar", to: "mailings#calendar", via: "get"
  match "/holidays", to: "mailings#holidays", via: "get"
  match "/timeline", to: "mailings#timeline", via: "get"

  get 'group_files/:id/:style/:basename.:extension' => 'group_files#render_file'
  get 'mailing_files/:id/:style/:basename.:extension' => 'mailing_files#render_file', :constraints => { :basename => /.*/ }

end

app/models/mailing_group.rb
class MailingGroup < ActiveRecord::Base
	belongs_to :subject_group
	belongs_to :level_group
	belongs_to :other_group
	belongs_to :mailing

	audited associated_with: :mailing
end

app/controllers/mailing_groups_controller.rb
class MailingGroupsController < ApplicationController
  before_action :set_mailing_group, only: [:show, :edit, :update, :destroy]

  respond_to :html

  def index
    @mailing_groups = MailingGroup.all
    respond_with(@mailing_groups)
  end

  def show
    respond_with(@mailing_group)
  end

  def new
    @mailing_group = MailingGroup.new
    respond_with(@mailing_group)
  end

  def edit
  end

  def create
    @mailing_group = MailingGroup.new(mailing_group_params)
    @mailing_group.save
    respond_with(@mailing_group)
  end

  def update
    @mailing_group.update(mailing_group_params)
    respond_with(@mailing_group)
  end

  def destroy
    @mailing_group.destroy
    respond_with(@mailing_group)
  end

  private
    def set_mailing_group
      @mailing_group = MailingGroup.find(params[:id])
    end

    def mailing_group_params
      params.require(:mailing_group).permit(:mailing_id, :level_group_id, :subject_group_id, :other_group_id)
    end
end

app/helpers/mailing_groups_helper.rb
module MailingGroupsHelper
end

app/views/mailing_groups/_form.html.erb
<%= form_for(@mailing_group) do |f| %>
  <% if @mailing_group.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@mailing_group.errors.count, "error") %> prohibited this mailing_group from being saved:</h2>

      <ul>
      <% @mailing_group.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :mailing_id %><br>
    <%= f.number_field :mailing_id %>
  </div>
  <div class="field">
    <%= f.label :level_group_id %><br>
    <%= f.number_field :level_group_id %>
  </div>
  <div class="field">
    <%= f.label :subject_group_id %><br>
    <%= f.number_field :subject_group_id %>
  </div>
  <div class="field">
    <%= f.label :other_group_id %><br>
    <%= f.number_field :other_group_id %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/mailing_groups/edit.html.erb
<h1>Editing Mailing Group</h1>

<%= render 'form' %>

<%= link_to 'Show', @mailing_group %> |
<%= link_to 'Back', mailing_groups_path %>

app/views/mailing_groups/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Mailing Groups</h1>

<table>
  <thead>
    <tr>
      <th>Mailing</th>
      <th>Level group</th>
      <th>Subject group</th>
      <th>Other group</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @mailing_groups.each do |mailing_group| %>
      <tr>
        <td><%= mailing_group.mailing_id %></td>
        <td><%= mailing_group.level_group_id %></td>
        <td><%= mailing_group.subject_group_id %></td>
        <td><%= mailing_group.other_group_id %></td>
        <td><%= link_to 'Show', mailing_group %></td>
        <td><%= link_to 'Edit', edit_mailing_group_path(mailing_group) %></td>
        <td><%= link_to 'Destroy', mailing_group, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Mailing group', new_mailing_group_path %>

app/views/mailing_groups/new.html.erb
<h1>New Mailing Group</h1>

<%= render 'form' %>

<%= link_to 'Back', mailing_groups_path %>

app/views/mailing_groups/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Mailing:</strong>
  <%= @mailing_group.mailing_id %>
</p>

<p>
  <strong>Level group:</strong>
  <%= @mailing_group.level_group_id %>
</p>

<p>
  <strong>Subject group:</strong>
  <%= @mailing_group.subject_group_id %>
</p>

<p>
  <strong>Other group:</strong>
  <%= @mailing_group.other_group_id %>
</p>

<%= link_to 'Edit', edit_mailing_group_path(@mailing_group) %> |
<%= link_to 'Back', mailing_groups_path %>